(*

OOO   OOO                OO
 OO   OO   OO           OOOO
 OO   OO                 OO
 OOOOOOO   OO   OO OOO   OO
 OO   OO   OO   OOO  OO  OO
 OO   OO   OO   OO   OO  OO
OOO   OOO OOOO OOO   OOO  OO

    OOO OOO OOOO    OOOOO   OOO OOO OOOO    OOOOO
     OOO  OOO  OO  OO   OO   OOO  OOO  OO  OO   OO
     OO    OO  OO  OOOOOOO   OO    OO  OO  OO   OO
     OO    OO  OO  OO        OO    OO  OO  OO   OO
    OOO    OO  OOO  OOOOO   OOO    OO  OOO  OOOOO

Jmno/Name:      		HintMemo
Autor/Author:    		Jan Rataj
Elektronick pota/e:Mail:    	honzara@bbs.infima.cz
Verze/Version:   		0.9  beta

*** Zruka *** Zruka *** Zruka *** Zruka *** Zruka *** Zruka *** Zruka ***
Pokud budete pouvat tyto komponenty, pouvte je na vlastn nebezpe. Nejsou 
mi znmy dn mon kody, kter by tento komponent mohl zpsobit. Nejsem tedy 
zodpovdn za dn kody, kter by mohly komponenty zpsobit na jinch
potach.
******************************************************************************

*** Disclaimer *** Disclaimer *** Disclaimer *** Disclaimer *** Disclaimer ***
I make no warranties regarding the use of this components and will not be held
responsible for any damages incurred from the use of this components.  I will
try to fix any bugs found in a reasonably timely manner, but in the case of
this not happening you have the source so fix it yourself.
******************************************************************************

Problm:   Nestrvil jsem s tmto komponentem mnoho asu, ale zd se mi, e 
dobe neuvoluje systmov zdroje Windows. 

Problems:  There is a problem with the resources. The component seems NOT to
free Windows resources. I did not spent long time with this component, so if
you want to improve it, please do it.

Pokud mte njak otzky nebo nvrhy, napite mi elektronickou potou.
If you have a question or suggestion, feel free contact me by e:Mail.

*)


unit HintMemo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TBaseLabel = class(TCustomLabel)
  published
    property Align;
    property Alignment;
    property AutoSize;
    property Caption;
    property Color;
    property DragCursor;
    property DragMode;
    property Enabled;
    property FocusControl;
    property Font;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property ShowAccelChar;
    property ShowHint;
    property Transparent;
    property Visible;
    property WordWrap;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;

  THintMemo = class(TBaseLabel)
  private
    { Private declarations }
    FShadow      : boolean;
    FShadowDelta : integer;
    FShadowColor : TColor;
    FRectangle   : boolean;
    FRounded     : boolean;
    FRoundedMargin: integer;
    FRoundedDelta: integer;
    FRectColor   : TColor;
    FLineColor   : TColor;
  protected
    { Protected declarations }
    Brd : integer; {offset pro kresleni obrazku}
    procedure Paint; override;
    procedure SetShadow( AShadow: boolean);
    procedure SetShadowDelta( AShadowDelta: integer);
    procedure SetShadowColor( AShadowColor: TColor);
    procedure SetRectangle( ARectangle: boolean);
    procedure SetRounded( ARounded: boolean);
    procedure SetRoundedMargin( ARoundedMargin: integer);
    procedure SetRoundedDelta( ARoundedDelta: integer);
    procedure SetRectColor( ARectColor: TColor);
    procedure SetLineColor( ALineColor: TColor);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property Shadow: boolean read FShadow write SetShadow default true;
    property ShadowDelta: integer read FShadowDelta
                                  write SetShadowDelta default 5;
    property ShadowColor: TColor read FShadowColor
                                  write SetShadowColor default clBlack;
    property Rectangle: boolean read FRectangle
                                  write SetRectangle default true;
    property Rounded: boolean read FRounded
                                  write SetRounded default true;
    property RoundedMargin: integer read FRoundedMargin
                                  write SetRoundedMargin default 5;
    property RoundedDelta: integer read FRoundedDelta
                                  write SetRoundedDelta default 10;
    property RectColor: TColor read FRectColor
                                  write SetRectColor default clYellow;
    property LineColor: TColor read FLineColor
                                  write SetLineColor default clBlack;
  end;

  TImageHintMemo = class(THintMemo)
  private
    FTipImage    : TBitmap;
  protected
    { Protected declarations }
    procedure Paint; override;
  public
    { Public declarations }
    constructor Create( AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetTipImage( Jaky: TBitmap);
  published                      
    { Published declarations }
    property TipImage: TBitmap read FTipImage
                               write SetTipImage;
  end;

procedure Register;


implementation

procedure Register;
begin
  RegisterComponents('Samples', [THintMemo]);
  RegisterComponents('Samples', [TImageHintMemo]);
end;

constructor THintMemo.Create;
begin
  inherited Create( AOwner);
  AutoSize:= false;
  FShadow:= true;
  FShadowDelta:= 5;
  FShadowColor:= clBlack;
  FRectangle:= true;
  FRounded:= true;
  FRoundedMargin:= 5;
  FRoundedDelta:= 5;
  FRectColor:= clYellow;
  FLineColor:= clBlack;
  Brd:= -1;
end;

procedure THintMemo.SetShadow;
begin
  if AShadow<> FShadow then begin
    FShadow:= AShadow;
    Refresh;
  end;
end;

procedure THintMemo.SetLineColor;
begin
  if ALineColor<> FLineColor then begin
    FLineColor:= ALineColor;
    Refresh;
  end;
end;

procedure THintMemo.SetRectColor;
begin
  if ARectColor<> FRectColor then begin
    FRectColor:= ARectColor;
    Refresh;
  end;
end;

procedure THintMemo.SetRoundedDelta;
begin
  if ARoundedDelta<> FRoundedDelta then begin
    FRoundedDelta:= ARoundedDelta;
    Refresh;
  end;
end;

procedure THintMemo.SetRoundedMargin;
begin
  if ARoundedMargin<> FRoundedMargin then begin
    FRoundedMargin:= ARoundedMargin;
    Refresh;
  end;
end;

procedure THintMemo.SetRounded;
begin
  if ARounded<> FRounded then begin
    FRounded:= ARounded;
    Refresh;
  end;
end;

procedure THintMemo.SetShadowDelta;
begin
  FShadowDelta:= AShadowDelta;
  Refresh;
end;

procedure THintMemo.SetShadowColor;
begin
  if AShadowColor<> FShadowColor then begin
    FShadowColor:= AShadowColor;
    Refresh;
  end;
end;

procedure THintMemo.SetRectangle;
begin
  if ARectangle<> FRectangle then begin
    FRectangle:= ARectangle;
    Refresh;
  end;
end;

procedure THintMemo.Paint;
var aDC: hDC;
    OldPen : WinTypes.hPen;
    OldBrush : WinTypes.hBrush;
    aPen: TPen;
    aBrush: TBrush;
    R1, R2: TRect;
    AF: TFont;
    PomStr: string;
    PomShade: longint;
    Alg: word;
begin
  aDC:= Canvas.Handle;

{  Caption:= 'skdjf lsd flksjhdf lksjdf lkshdf lks dflkshjf dlks lfkdh sldkhf';
  FShadow:= true; FRounded:= true;
  FShadowColor:= clBlack;
  FRoundedDelta:= 10; FShadowDelta:= 2;
  FRoundedMargin:= 5;
  FRectColor:= clYellow; FLineColor:= clBlack;}

  aPen:= TPen.Create;
  aBrush:= TBrush.Create;

 {erase all}
  aPen.Color:= Color;
  aBrush.Color:= aPen.Color;
  OldPen:= SelectObject( aDC, aPen.Handle);
  OldBrush:= SelectObject( aDC, aBrush.Handle);
  WinProcs.Rectangle( aDC,
                      0, 0,
                      Width, Height);

 {paint it}
  if FShadow then begin
    aPen.Color:= FShadowColor;
    aBrush.Color:= FShadowColor;
    SelectObject( aDC, aPen.Handle);
    SelectObject( aDC, aBrush.Handle);
    if FRounded then begin
      RoundRect( aDC, FRoundedMargin+ FShadowDelta,
                      FRoundedMargin+ FShadowDelta,
                      Width- FRoundedMargin+ FShadowDelta,
                      Height- FRoundedMargin+ FShadowDelta{+ 1},
                      FRoundedDelta, FRoundedDelta);
    end else begin
      WinProcs.Rectangle( aDC,
                          FRoundedMargin+ FShadowDelta,
                          FRoundedMargin+ FShadowDelta,
                          Width- FRoundedMargin+ FShadowDelta,
                          Height- FRoundedMargin+ FShadowDelta{+ 1});
    end;
  end;
  aPen.Color:= FLineColor;
  aBrush.Color:= FRectColor;
  SelectObject( aDC, aPen.Handle);
  SelectObject( aDC, aBrush.Handle);
  if FRounded then begin
    RoundRect( aDC, FRoundedMargin, FRoundedMargin,
                    Width- FRoundedMargin,
                    Height- FRoundedMargin,
                    FRoundedDelta, FRoundedDelta);
  end else begin
    WinProcs.Rectangle( aDC, FRoundedMargin, FRoundedMargin,
                        Width- FRoundedMargin,
                        Height- FRoundedMargin);
  end;

  with R1 do begin
    Left:= Brd+ FRoundedMargin+ 3; Top:= FRoundedMargin+ 2;
    Right:= Width- FRoundedMargin- 3;
    Bottom:= Height- FRoundedMargin- 3;
  end;
  PomStr:= Caption;
  AF:= Canvas.Font;
  Canvas.Font:= Font;
  Canvas.Brush.Color:= Color;
{  if Transparent then}
    SetBkMode( Canvas.Handle, WinTypes.Transparent);
  Case Alignment of
    taLeftJustify: Alg:= dt_Left;
    taRightJustify: Alg:= dt_Right;
  else
    Alg:= dt_Center;
  end;
  WinProcs.DrawText( Canvas.Handle, @PomStr[ 1], length( PomStr),
                     R1, dt_WordBreak or Alg);
  Canvas.Font:= AF;

  SelectObject( aDC, OldPen);
  SelectObject( aDC, OldBrush);
 { ReleaseDC( Handle, aDC);}
  aPen.Free;
  aBrush.Free;
end;

constructor TImageHintMemo.Create;
begin
  inherited Create( AOwner);
  FTipImage:= TBitmap.Create;
  FTipImage.LoadFromFile( 'c:\windows\pic\tip3.bmp');
end;

destructor TImageHintMemo.Destroy;
begin
  FTipImage.Free;
  inherited Destroy;
end;

procedure TImageHintMemo.Paint;
var R1, R2: TRect;
begin
  if FTipImage<> nil then begin
    Brd:= FTipImage.Width+ 2;
    inherited Paint;

    with R1 do begin
      Left:= FRoundedMargin+ 3; Top:= FRoundedMargin+ 3;
      Right:= FRoundedMargin+ FTipImage.Width+ 3;
      Bottom:= FRoundedMargin+ FTipImage.Height+ 3;
    end;
    with R2 do begin
      Left:= 0; Top:= 0;
      Right:= FTipImage.Width;
      Bottom:= FTipImage.Height;
    end;
    Canvas.Brush.Color:= RectColor;
    Canvas.BrushCopy( R1, FTipImage, R2, FTipImage.Canvas.Pixels[ 0, 0]);
  end else begin
    Brd:= 0;
    inherited Paint;
  end;
end;

procedure TImageHintMemo.SetTipImage;
begin
  FTipImage.Assign( Jaky);
{  Jaky.Free;}
end;

end.
